package com.example.acer.agendita_mysql_c;

import android.app.ProgressDialog;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;

import librerias.ConexionWeb;
import librerias.Datos;
import librerias.ListaAdapter;
import librerias.MiBaseDatos;
import librerias.Parametros;


public class ConsultasFragment extends Fragment {
    EditText txtTelefono;
    ListView lista;
    MiBaseDatos baseDatos;
    ListaAdapter adaptador;
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_consultas, container, false);
    }
    public void onStart(){
        super.onStart();
        txtTelefono=(EditText)getView().findViewById(R.id.txtTelBuscarConsultas);
        lista=(ListView)getView().findViewById(R.id.listaConsultas);
        adaptador=new ListaAdapter(getContext());
        adaptador.notifyDataSetChanged();
        lista.setAdapter(adaptador);

        TextWatcher textWatcher = new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {
            }
            @Override
            public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {
            }
            @Override
            public void afterTextChanged(Editable editable) {

                if(Parametros.conexion.equals("Local")){
                    buscarLocal();
                }else {
                    buscarRemoto();
                }
            }
        };
        txtTelefono.addTextChangedListener(textWatcher);
    }

    public void buscarRemoto(){

            ArrayList<String> valores = new ArrayList();
            String telefono = txtTelefono.getText().toString();
            valores.add(0, telefono);
            new TareaBuscarWeb(valores).execute();

    }
    public void mostrarDato(ArrayList<Datos> datos){
        adaptador.clear();
        for(int i=0;i<datos.size();i++){
            Datos dato=datos.get(i);
            adaptador.add(new Datos(
                    dato.getNombre(),
                    dato.getApellido(),
                    dato.getTelefono()));

        }
        adaptador.notifyDataSetChanged();
    }

    public void buscarLocal(){
            adaptador.clear();
            baseDatos=new MiBaseDatos(getContext());
            SQLiteDatabase sql=baseDatos.getReadableDatabase();
            String[] columnas={
                    Parametros.campo_nombre,
                    Parametros.campo_apellido,
                    Parametros.campo_telefono};
            String consulta = "telefono LIKE '" + txtTelefono.getText().toString()  + "%'";
            String ordenSalida = "telefono DESC";
        Cursor cursor = sql.query(Parametros.tabla_datos, columnas, consulta,null , null, null, null);

        if(cursor.getCount() != 0)
        {
            cursor.moveToFirst();
            adaptador.add(new Datos(
                    cursor.getString(cursor.getColumnIndex(Parametros.campo_nombre)),
                    cursor.getString(cursor.getColumnIndex(Parametros.campo_apellido)),
                    cursor.getString(cursor.getColumnIndex(Parametros.campo_telefono))));
            adaptador.notifyDataSetChanged();
            lista.setAdapter(adaptador);
            sql.close();
        }
        else
        {
            Toast.makeText(getContext(), "No Existe ninguna Considencia ", Toast.LENGTH_LONG).show();
        }
    }
    private class TareaBuscarWeb extends AsyncTask<Void, Void, String> {
        String URL = "http://"+Parametros.servidor+"/EjemploMysql/Consultas.php";
        // private JSONArray jsonDatos = null;
        ArrayList<String> valores;
        private JSONArray jsonDatos = null;
        ArrayList<Datos> ArrayDato=new ArrayList();
        private ProgressDialog nDialog;
        String jsonStr=null;
        public TareaBuscarWeb(ArrayList<String> valores){
            nDialog = new ProgressDialog(getActivity());
            this.valores=valores;
        }
        @Override
        //accion principal
        protected String doInBackground(Void... voids) {

            ArrayList<String> keys = new ArrayList();
            ArrayList<String> valor = new ArrayList();

            keys.add(0, "telefono");valor.add(0, valores.get(0));
            ConexionWeb conexionWeb = new ConexionWeb();
            try {
                jsonStr = conexionWeb.buscarDato(URL, conexionWeb.armarGET(keys,valor));


                //duracion de la ventana 3000 milisegundos
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            return null;
        }
        //accion previa
        protected void onPreExecute() {
            nDialog.show();
            nDialog.setContentView(R.layout.dialogo_grabando);


        }
        //accion posterior
        protected void onPostExecute(String result) {
            super.onPostExecute(result);
            try {
                JSONObject json = new JSONObject(jsonStr);
                if (!json.isNull("datos")) {
                    Log.d("Json Recibido",jsonStr);
                    jsonDatos = json.getJSONArray("datos");
                    for (int i = 0; i < jsonDatos.length(); i++) {
                        JSONObject jsonObject = jsonDatos.getJSONObject(i);
                        ArrayDato.add(new Datos(jsonObject.getString("nombre"),
                                jsonObject.getString("apellido"),
                                jsonObject.getString("telefono")));
                    }
                } else {
                    Log.d("Json:", "Vacio");
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            if (nDialog.isShowing()) {
                nDialog.dismiss();
                mostrarDato(ArrayDato);

            }
        }

    }

}
